org.springframework.transaction.support

## Class ResourceHolderSynchronization<H extends ResourceHolder,K>

- java.lang.Object
- - org.springframework.transaction.support.ResourceHolderSynchronization<H,K>

- Type Parameters:
    `H` - the resource holder type
    `K` - the resource key type
  All Implemented Interfaces:
    Flushable, Ordered, TransactionSynchronization

      public abstract class ResourceHolderSynchronization<H extends ResourceHolder,K>
      extends Object
      implements TransactionSynchronization

  `TransactionSynchronization` implementation that manages a `ResourceHolder` bound through `TransactionSynchronizationManager`.
  Since:
    2.5.5
  Author:
    Juergen Hoeller

- - ### Field Summary

    - ### Fields inherited from interface org.springframework.transaction.support.TransactionSynchronization

      `STATUS_COMMITTED, STATUS_ROLLED_BACK, STATUS_UNKNOWN`

    - ### Fields inherited from interface org.springframework.core.Ordered

      `HIGHEST_PRECEDENCE, LOWEST_PRECEDENCE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ResourceHolderSynchronization(H resourceHolder, K resourceKey)` Create a new ResourceHolderSynchronization for the given holder.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterCommit()` Invoked after transaction commit.
    `void` | `afterCompletion(int status)` Invoked after transaction commit/rollback.
    `void` | `beforeCommit(boolean readOnly)` Invoked before transaction commit (before "beforeCompletion").
    `void` | `beforeCompletion()` Invoked before transaction commit/rollback.
    `protected void` | `cleanupResource(H resourceHolder, K resourceKey, boolean committed)` Perform a cleanup on the given resource (which is left bound to the thread).
    `void` | `flush()` Flush the underlying session to the datastore, if applicable: for example, a Hibernate/JPA session.
    `protected void` | `flushResource(H resourceHolder)` Flush callback for the given resource holder.
    `protected void` | `processResourceAfterCommit(H resourceHolder)` After-commit callback for the given resource holder.
    `protected void` | `releaseResource(H resourceHolder, K resourceKey)` Release the given resource (after it has been unbound from the thread).
    `void` | `resume()` Resume this synchronization.
    `protected boolean` | `shouldReleaseAfterCompletion(H resourceHolder)` Return whether this holder's resource should be released after transaction completion (`true`).
    `protected boolean` | `shouldReleaseBeforeCompletion()` Return whether this holder's resource should be released before transaction completion (`true`) or rather after transaction completion (`false`).
    `protected boolean` | `shouldUnbindAtCompletion()` Return whether this holder should be unbound at completion (or should rather be left bound to the thread after the transaction).
    `void` | `suspend()` Suspend this synchronization.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.springframework.transaction.support.TransactionSynchronization

      `getOrder`

- - ### Constructor Detail

    - #### ResourceHolderSynchronization

          public ResourceHolderSynchronization(H resourceHolder,
                                               K resourceKey)

      Create a new ResourceHolderSynchronization for the given holder.
      Parameters:
        `resourceHolder` - the ResourceHolder to manage
        `resourceKey` - the key to bind the ResourceHolder for
      See Also:
        `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`

  - ### Method Detail

    - #### suspend

          public void suspend()

      Description copied from interface: `TransactionSynchronization`
      Suspend this synchronization. Supposed to unbind resources from TransactionSynchronizationManager if managing any.
      Specified by:
        `suspend` in interface `TransactionSynchronization`
      See Also:
        `TransactionSynchronizationManager.unbindResource(java.lang.Object)`

    - #### resume

          public void resume()

      Description copied from interface: `TransactionSynchronization`
      Resume this synchronization. Supposed to rebind resources to TransactionSynchronizationManager if managing any.
      Specified by:
        `resume` in interface `TransactionSynchronization`
      See Also:
        `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`

    - #### flush

          public void flush()

      Description copied from interface: `TransactionSynchronization`
      Flush the underlying session to the datastore, if applicable: for example, a Hibernate/JPA session.
      Specified by:
        `flush` in interface `Flushable`
      Specified by:
        `flush` in interface `TransactionSynchronization`
      See Also:
        `TransactionStatus.flush()`

    - #### beforeCommit

          public void beforeCommit(boolean readOnly)

      Description copied from interface: `TransactionSynchronization`
      Invoked before transaction commit (before "beforeCompletion"). Can e.g. flush transactional O/R Mapping sessions to the database.

      This callback does not mean that the transaction will actually be committed. A rollback decision can still occur after this method has been called. This callback is rather meant to perform work that's only relevant if a commit still has a chance to happen, such as flushing SQL statements to the database.

      Note that exceptions will get propagated to the commit caller and cause a rollback of the transaction.

      Specified by:
        `beforeCommit` in interface `TransactionSynchronization`
      Parameters:
        `readOnly` - whether the transaction is defined as read-only transaction
      See Also:
        `TransactionSynchronization.beforeCompletion()`

    - #### beforeCompletion

          public void beforeCompletion()

      Description copied from interface: `TransactionSynchronization`
      Invoked before transaction commit/rollback. Can perform resource cleanup before transaction completion.

      This method will be invoked after `beforeCommit`, even when `beforeCommit` threw an exception. This callback allows for closing resources before transaction completion, for any outcome.

      Specified by:
        `beforeCompletion` in interface `TransactionSynchronization`
      See Also:
        `TransactionSynchronization.beforeCommit(boolean)`, `TransactionSynchronization.afterCompletion(int)`

    - #### afterCommit

          public void afterCommit()

      Description copied from interface: `TransactionSynchronization`
      Invoked after transaction commit. Can perform further operations right after the main transaction has successfully committed.

      Can e.g. commit further operations that are supposed to follow on a successful commit of the main transaction, like confirmation messages or emails.

      NOTE: The transaction will have been committed already, but the transactional resources might still be active and accessible. As a consequence, any data access code triggered at this point will still "participate" in the original transaction, allowing to perform some cleanup (with no commit following anymore!), unless it explicitly declares that it needs to run in a separate transaction. Hence: Use `PROPAGATION_REQUIRES_NEW` for any transactional operation that is called from here.

      Specified by:
        `afterCommit` in interface `TransactionSynchronization`

    - #### afterCompletion

          public void afterCompletion(int status)

      Description copied from interface: `TransactionSynchronization`
      Invoked after transaction commit/rollback. Can perform resource cleanup after transaction completion.

      NOTE: The transaction will have been committed or rolled back already, but the transactional resources might still be active and accessible. As a consequence, any data access code triggered at this point will still "participate" in the original transaction, allowing to perform some cleanup (with no commit following anymore!), unless it explicitly declares that it needs to run in a separate transaction. Hence: Use `PROPAGATION_REQUIRES_NEW` for any transactional operation that is called from here.

      Specified by:
        `afterCompletion` in interface `TransactionSynchronization`
      Parameters:
        `status` - completion status according to the `STATUS_*` constants
      See Also:
        `TransactionSynchronization.STATUS_COMMITTED`, `TransactionSynchronization.STATUS_ROLLED_BACK`, `TransactionSynchronization.STATUS_UNKNOWN`, `TransactionSynchronization.beforeCompletion()`

    - #### shouldUnbindAtCompletion

          protected boolean shouldUnbindAtCompletion()

      Return whether this holder should be unbound at completion (or should rather be left bound to the thread after the transaction).

      The default implementation returns `true`.

    - #### shouldReleaseBeforeCompletion

          protected boolean shouldReleaseBeforeCompletion()

      Return whether this holder's resource should be released before transaction completion (`true`) or rather after transaction completion (`false`).

      Note that resources will only be released when they are unbound from the thread (`shouldUnbindAtCompletion()`).

      The default implementation returns `true`.

      See Also:
        `releaseResource(H, K)`

    - #### shouldReleaseAfterCompletion

          protected boolean shouldReleaseAfterCompletion(H resourceHolder)

      Return whether this holder's resource should be released after transaction completion (`true`).

      The default implementation returns `!shouldReleaseBeforeCompletion()`, releasing after completion if no attempt was made before completion.

      See Also:
        `releaseResource(H, K)`

    - #### flushResource

          protected void flushResource(H resourceHolder)

      Flush callback for the given resource holder.
      Parameters:
        `resourceHolder` - the resource holder to flush

    - #### processResourceAfterCommit

          protected void processResourceAfterCommit(H resourceHolder)

      After-commit callback for the given resource holder. Only called when the resource hasn't been released yet (`shouldReleaseBeforeCompletion()`).
      Parameters:
        `resourceHolder` - the resource holder to process

    - #### releaseResource

          protected void releaseResource(H resourceHolder,
                                         K resourceKey)

      Release the given resource (after it has been unbound from the thread).
      Parameters:
        `resourceHolder` - the resource holder to process
        `resourceKey` - the key that the ResourceHolder was bound for

    - #### cleanupResource

          protected void cleanupResource(H resourceHolder,
                                         K resourceKey,
                                         boolean committed)

      Perform a cleanup on the given resource (which is left bound to the thread).
      Parameters:
        `resourceHolder` - the resource holder to process
        `resourceKey` - the key that the ResourceHolder was bound for
        `committed` - whether the transaction has committed (`true`) or rolled back (`false`)